﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;

namespace Nomenclator
{
    public partial class FNomenclator : Form
    {
        private String años = "";
        private int inicial, final;

        public FNomenclator()
        {
            InitializeComponent();

            CargarProvicias();
            CargarAños();
        }

        private void CargarProvicias()
        {
            for (int i = 1; i <= 52;i++ )
            {
                CBProvinciaFinal.Items.Add(i);
                CBProvinciaInicial.Items.Add(i);
            }
            CBProvinciaFinal.SelectedIndex = 0;
            CBProvinciaInicial.SelectedIndex = 0;
        }

        private void CargarAños()
        {
            for (int i = 2000; i <= 2007; i++)
            {
                LBAños.Items.Add(i);
            }
            LBAños.SelectedIndex = LBAños.Items.Count - 1;
        }

        private void DescargarPaginasProvincias(int ini, int fin)
        {
            int np = 0;
            int cp = 0;
            try
            {
                String resultado = "";
                
                HttpWebResponse myRes;
                HttpWebRequest myReq;
                CookieCollection Cookies=new CookieCollection();
                System.IO.Stream receiveStream;
                System.IO.StreamReader readStream;
                Encoding enc = Encoding.GetEncoding("iso-8859-1");

                Boolean error = false;

                String paginaLeida = "";

                for (int i = ini; i <= fin; i++)
                {
                    cp = i;
                    np = 0;
                    error = false;
                    Cookies = new CookieCollection();
                    while (!error)
                    {
                        try
                        {
                            if (np == 0)
                                myReq = (HttpWebRequest)WebRequest.Create("http://www.ine.es/nomen2/index.do?accion=busquedaAvanzada&subaccion=&numPag=" + np.ToString() + "&ordenAnios=DESC&textoPorDefectoEnCuadros=&comunidad=00&entidad_amb=no&codProv=" + cp.ToString() + "&codMuni=&codEC=&codES=&codNUC=&poblacion_amb=T&poblacion_op=%3D&poblacion_txt=&denominacion_op=like&denominacion_txt=" + años + "&CONSULAVAN.x=39&CONSULAVAN.y=7");
                            else
                                myReq = (HttpWebRequest)WebRequest.Create("http://www.ine.es/nomen2/tabla.do?numPag=" + np.ToString() + "&ordenCab=anio-sex");
                            myReq.Method = "GET";
                            myReq.CookieContainer = new System.Net.CookieContainer();
                            myReq.CookieContainer.Add(Cookies);
                            myRes = (HttpWebResponse)myReq.GetResponse();

                            receiveStream = myRes.GetResponseStream();
                            readStream = new System.IO.StreamReader(receiveStream, enc);
                            paginaLeida = "";
                            while (!readStream.EndOfStream)
                            {
                                paginaLeida += readStream.ReadLine();
                            }
                            if (np == 0 && cp==ini)
                            {
                                //Si les la primera paginas cogemos el segundo encabecado
                                resultado = LimpiarTabla(paginaLeida, 0);
                            }
                            else
                            {
                                resultado = resultado + LimpiarTabla(paginaLeida, 2);
                            }
                            backgroundWorker1.ReportProgress(0, "Se ha descargado la pagina " + np.ToString() + " de la provincia " + cp.ToString() + "...");
                            Application.DoEvents();
                            if (np == 0)
                            {
                                // Cojemos la Cookies de la primera pagina para poder llamar al resto
                                Cookies = myRes.Cookies;
                            }
                            np = np + 1;
                        }
                        catch(WebException ex)
                        {
                            error = true;
                        }
                    }
                }
                resultado = CrearTabla(resultado);
                // Por ultimo creamos el archivo
                SalvarHTML(resultado, ini, fin);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void SalvarHTML(String html, int ini, int fin){
            System.IO.StreamWriter sw = new System.IO.StreamWriter("Provincias "+ ini.ToString()+"-"+fin.ToString()+".htm",false,Encoding.UTF8);
            sw.Write(html);
            sw.Close();
        }

        private String LimpiarTabla(String html, int cabecerasEliminadas)
        {
            // Quitamos lo anterior y posterios a la tabla.
            String [] cadenas=html.Split(new string[] {"<TABLE BORDER=\"0\" WIDTH=\"100%\" summary=\"Cuerpo del html\">"},StringSplitOptions.RemoveEmptyEntries);
            cadenas = cadenas[1].Split(new string[] {"</TABLE>"},StringSplitOptions.RemoveEmptyEntries);
            // Cojemos la tabla que nos ha quedado
            html = cadenas[0];
            // Quitarmos las Cabeceras
            html = QuitarCabeceras(html, cabecerasEliminadas);
            return html;
        }

        private String CrearTabla(String html)
        {
            // Motamos la tabla
            return "<TABLE BORDER=\"0\" WIDTH=\"100%\" summary=\"Cuerpo del html\">" + html + "</TABLE>";
        }

        private String QuitarCabeceras(String html,int eliminadas)
        {
            System.Collections.ArrayList lista= new System.Collections.ArrayList();
            String[] filas = html.Split(new string[] { "</TR>" }, StringSplitOptions.RemoveEmptyEntries);
            html = "";
            for (int i = eliminadas; i < filas.Length; i++)
            {
                html = html + filas[i] + "</TR>";
            }
            return html;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            int inicial = int.Parse(CBProvinciaInicial.SelectedItem.ToString());
            int final = int.Parse(CBProvinciaFinal.SelectedItem.ToString());
            if (inicial <= final)
            {
                if (GenerarCadenaAños())
                {
                    button1.Enabled = false;
                    button2.Enabled = true;
                    listBox1.Items.Clear();
                    listBox1.Items.Add("Se ha iniciado la creación de los archivos...");
                    backgroundWorker1.RunWorkerAsync(inicial.ToString()+"-"+final.ToString());
                }
                else
                {
                    MessageBox.Show("Debe elegir algun año.");
                }
            }
            else
            {
                MessageBox.Show("La provincia de inicio es mayor que la de fin.");
            }
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            String [] rangos=e.Argument.ToString().Split('-');
            inicial = int.Parse(rangos[0]);
            final = int.Parse(rangos[1]);
            DescargarPaginasProvincias(inicial,final);
        }

        private Boolean GenerarCadenaAños()
        {
            // Genera la cadena de busqueda de los años.
            // Nos devuelve si se ha generado o no.
            Boolean generado = false;
            años="";
            foreach(int año in LBAños.SelectedItems){
                años=años+"&anos="+año.ToString();
                generado = true;
            }
            return generado;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            backgroundWorker1.CancelAsync();
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            MessageBox.Show("Ha finalizado correctamente.");
            listBox1.SelectedIndex = listBox1.Items.Count - 1;
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            listBox1.Items.Add(e.UserState);
            listBox1.SelectedIndex = listBox1.Items.Count - 1;
        }
    }
}